// Created  by John Liaperdos and George Theophanous, July 2015

var beta=100;
var VBE=0.7;
var VBB=5;
var VCC=15;
var RB=100000; // in Ohms
var RC=500; // in Ohms

function initializeBJTCurrentSource(){
	document.getElementById('RC_text').textContent='=0.5kΩ';
	document.getElementById('IC_text').textContent=calculateIC();	
}

function calculateIC(){	// returns mA
	I_c=beta*(VBB-VBE)/RB;
	if(VCC-I_c*RC<=0.2) I_c=(VCC-0.2)/RC;
	return Math.round(100000*I_c)/100;
}

function increaseRC(){
	if(RC<10000)
	{
		RC=RC+100;
	}
	document.getElementById('RC_text').textContent='='+(RC/1000)+'kΩ';
	document.getElementById('IC_text').textContent=calculateIC();
}

function decreaseRC(){
	if(RC>500)
	{
		RC=RC-100;
	}
	document.getElementById('RC_text').textContent='='+(RC/1000)+'kΩ';
	document.getElementById('IC_text').textContent=calculateIC();
}





