// Created  by John Liaperdos and George Theophanous, August 2015

function logic_function(x,y,z,w){
	//((A AND B) AND ((A AND C) OR (B AND D)))
	output_val=((x&y)&((x&z)|(y&w)));
	return output_val;
}

function initializeSwitchingCircuit(){
	document.getElementById('switch_1_closed').style.display='none';
	document.getElementById('switch_2_closed').style.display='none';
	document.getElementById('switch_3_closed').style.display='none';
	document.getElementById('switch_4_closed').style.display='none';
	document.getElementById('switch_5_closed').style.display='none';
	document.getElementById('switch_6_closed').style.display='none';
	document.getElementById('ammeter_indicator_max').style.display='none';
	document.getElementById('lamp_color').style.fill='gray';
	document.getElementById('x_digit').textContent=0;
	document.getElementById('y_digit').textContent=0;
	document.getElementById('z_digit').textContent=0;
	document.getElementById('w_digit').textContent=0;
}

function toggleDigit(digit_id){
	current_val=document.getElementById(digit_id+'_digit').textContent;
	if(current_val=='0')
	{
		document.getElementById(digit_id+'_digit').textContent=1;
		if(digit_id=='x')
		{
			document.getElementById('switch_1_closed').style.display='inline';
			document.getElementById('switch_4_closed').style.display='inline';	
			document.getElementById('switch_1_open').style.display='none';
			document.getElementById('switch_4_open').style.display='none';				
		}
		if(digit_id=='y')
		{
			document.getElementById('switch_2_closed').style.display='inline';
			document.getElementById('switch_5_closed').style.display='inline';	
			document.getElementById('switch_2_open').style.display='none';
			document.getElementById('switch_5_open').style.display='none';			
		}		
		if(digit_id=='z')
		{
			document.getElementById('switch_6_closed').style.display='inline';
			document.getElementById('switch_6_open').style.display='none';		
		}
		if(digit_id=='w')
		{
			document.getElementById('switch_3_closed').style.display='inline';
			document.getElementById('switch_3_open').style.display='none';		
		}
	}
	else
	{
		document.getElementById(digit_id+'_digit').textContent=0;
		if(digit_id=='x')
		{
			document.getElementById('switch_1_closed').style.display='none';
			document.getElementById('switch_4_closed').style.display='none';	
			document.getElementById('switch_1_open').style.display='inline';
			document.getElementById('switch_4_open').style.display='inline';				
		}
		if(digit_id=='y')
		{
			document.getElementById('switch_2_closed').style.display='none';
			document.getElementById('switch_5_closed').style.display='none';	
			document.getElementById('switch_2_open').style.display='inline';
			document.getElementById('switch_5_open').style.display='inline';			
		}		
		if(digit_id=='z')
		{
			document.getElementById('switch_6_closed').style.display='none';
			document.getElementById('switch_6_open').style.display='inline';		
		}
		if(digit_id=='w')
		{
			document.getElementById('switch_3_closed').style.display='none';
			document.getElementById('switch_3_open').style.display='inline';		
		}
	}
	drawResults();
}

function drawResults(){
	document.getElementById('ammeter_indicator_max').style.display='none';
	document.getElementById('ammeter_indicator_min').style.display='none';
	document.getElementById('lamp_color').style.fill='gray';
	x_val=(document.getElementById('x_digit').textContent=='1');
	y_val=(document.getElementById('y_digit').textContent=='1');
	z_val=(document.getElementById('z_digit').textContent=='1');
	w_val=(document.getElementById('w_digit').textContent=='1');
	output_val=logic_function(x_val,y_val,z_val,w_val);
	if(output_val)
	{
		document.getElementById('ammeter_indicator_max').style.display='inline';
		document.getElementById('lamp_color').style.fill='yellow';		
	}
	else
	{
		document.getElementById('ammeter_indicator_min').style.display='inline';
	};
}


