// Created by John Liaperdos - August 2, 2015
// Modified: August 27, 2015   

var searchResultsArray=[]; 
var numberOfTermOccurrencesArray=[]; 
var timeoutVar;
var ajaxResponseReadyArray=[];
var setIntervalVal;	
var setIntervalValRemote;	
var perform_detailed_search=false;
var currentHighlightIndex;
var totalHighlights=0;
var highlightElementIdArray=[];
var current_search_term;
var chapterTitlesArray=['Εισαγωγικές Γνώσεις', 'Επαφή p-n, Δίοδοι', 'Διπολικά τρανζίστορ', 'Τρανζίστορ επίδρασης πεδίου – MOSFET', 'Ψηφιακά λογικά κυκλώματα ', 'Ενισχυτές', 'Φίλτρα', 'Ταλαντωτές']

// preload images
	var remove_highlight_active_Image=new Image();
    remove_highlight_active_Image.src="../images/misc/remove_highlight_active.png";
	var highlight_Image=new Image();
    highlight_Image.src="../images/misc/highlight.png";
	var no_highlight_Image=new Image();
    no_highlight_Image.src="../images/misc/no_highlight.png";
	var search_goto_previous_Image=new Image();
    search_goto_previous_Image.src="../images/misc/search_goto_previous.png";
	var search_goto_next_Image=new Image();
    search_goto_next_Image.src="../images/misc/search_goto_next.png";
		

function removeLaTeXMath(input_string){
	current_dollar_occurrence=0;
	while (current_dollar_occurrence>=0) 
	{
		current_dollar_occurrence=input_string.indexOf("$",0);
		next_dollar_occurrence=input_string.indexOf("$",current_dollar_occurrence+1);
		math_string=input_string.substr(current_dollar_occurrence,next_dollar_occurrence-current_dollar_occurrence+1);
		if(math_string=='$$')
		{
			next_dollar_occurrence=input_string.indexOf("$$",next_dollar_occurrence+1)+1;
			math_string=input_string.substr(current_dollar_occurrence,next_dollar_occurrence-current_dollar_occurrence+1);
		};
		input_string=input_string.replaceAll(math_string,"");
	};
	return input_string;
}

function searchTermFunction(searchTerm,chapterNumber)
{
	chapterFileName="chapter_0"+(chapterNumber+1)+".xhtml";	
	$.ajax({url: chapterFileName, dataType: "xml", cache: false, success: 
		function(result){
				result.getElementById("floatdiv").innerHTML="";
				//ignore
					result = $(result).find("title, script, noscript, style, #current_section, #next_section, #previous_section").remove().end(); 				
				textOnly = result.text(); // convert to text	
				textOnly = removeLaTeXMath(textOnly); // Remove LaTeX code
				textOnly=textOnly.myLowerCase(); // to lowercase
				textOnly=stripAccents(textOnly); // Remove accents	
				searchTerm = searchTerm.replace(/[&\/\\#,+()$~%.'":*?<>{}]/g, ''); // remove special chars from search term
				search_result=textOnly.search(searchTerm);
				searchResultsArray[chapterNumber]=search_result;
				ajaxResponseReadyArray[chapterNumber]=1;
				if(perform_detailed_search==true)
				{				
					regularExpression = new RegExp(searchTerm, "gi");
					matchResult=textOnly.match(regularExpression);
					if(matchResult===null)
					{
						numberOfTermOccurrencesArray[chapterNumber]=0;
					}
					else
					{
						numberOfTermOccurrencesArray[chapterNumber]=matchResult.length;
					};
				};
		}
	});
}

function searchForTermRemote(searchTerm)
{
	searchTerm=searchTerm.trim(); // Remove whitespace from both sides	
	searchTerm=stripAccents(searchTerm); // Remove accents
	searchTerm=searchTerm.myLowerCase(); // convert to lowercase
	for (i = 0; i < 8; i++) 
	{
		ajaxResponseReadyArray[i]=0;
	};
	for (i = 0; i < 8; i++) 
	{
		searchTermFunction(searchTerm,i);
	};
	setIntervalValRemote=setInterval(showSearchResultsRemote,1000); // try until all ajax responses are collected
}

function clearMessageDiv(){
	try{
		clearTimeout(timeoutVar);
	}
	catch(err){};
	timeoutVar=setTimeout(function(){
		search_error_div=document.getElementById('search_error_div');
		search_error_div.innerHTML=" ";
	},4000)
}

function searchForTerm()
{	
	search_error_div=document.getElementById('search_error_div');
	document.getElementById("searchTermText").disabled=true;
	document.getElementById("searchButton").disabled=true;
	document.getElementById("detailed_results_checkbox").disabled=true;
	search_error_div.innerHTML="Εκτελείται αναζήτηση ...";
	search_error_div.style.color='blue';
	document.getElementById('searchResultsDiv').style.display="none";
	searchTerm=document.getElementById('searchTermText').value;
	document.body.style.cursor='wait';
	for (i = 0; i < 8; i++) 
	{
		document.getElementById('term_in_chapter_'+(i+1)).style.display="none";
		ajaxResponseReadyArray[i]=0;
		numberOfTermOccurrencesArray[i]=0;
	}
	if(searchTerm.search(/[&\/\\#,+()$~%.'":*?<>{}]/g, '')!=-1) // special chars
		{
			search_error_div.innerHTML="Δεν επιτρέπονται ειδικοί χαρακτήρες."	
			clearMessageDiv();
			document.body.style.cursor='auto';
			search_error_div.style.color='red';	
			document.getElementById("searchTermText").disabled=false;
			document.getElementById("searchButton").disabled=false;	
			document.getElementById("detailed_results_checkbox").disabled=false;
			return;			
		};
	searchTerm=searchTerm.trim(); // Remove whitespace from both sides	
	searchTerm=stripAccents(searchTerm); // Remove accents
	searchTerm=searchTerm.myLowerCase(); // convert to lowercase
	if (searchTerm=='' || searchTerm.length<3)
	{
		if(searchTerm=='')
		{
			search_error_div.innerHTML="Δεν πληκτρολογήσατε όρο για αναζήτηση."	
		}
		else
		{
			search_error_div.innerHTML="Πληκτρολογήστε τουλάχιστον τρεις χαρακτήρες."	
		}	
		;
		clearMessageDiv();
		document.body.style.cursor='auto';
		search_error_div.style.color='red';	
		document.getElementById("searchTermText").disabled=false;
		document.getElementById("searchButton").disabled=false;	
		document.getElementById("detailed_results_checkbox").disabled=false;
		return;
	}
	for (i = 0; i < 8; i++) 
	{
		searchTermFunction(searchTerm,i);
	}
	setIntervalVal=setInterval(showSearchResults,1000); // try until all ajax responses are collected
}

function showSearchResults()
{
	document.getElementById("detailed_search_results").innerHTML='';
	if(ajaxResponseReadyArray.indexOf(0)!=-1){return}; // return if not all ajax responses are collected
	clearInterval(setIntervalVal); // stop waiting
	chapter_count=0;
	for (i = 0; i < 8; i++) 
	{
		if(searchResultsArray[i]!=-1)
		{
			chapter_count=chapter_count+1;
		}
	};
	if(chapter_count==0)
	{
		search_error_div.style.color='red';	
		search_error_div.innerHTML="Η αναζήτηση δεν απέδωσε αποτελέσματα.";
		clearMessageDiv();
		document.body.style.cursor='auto';	
		document.getElementById("searchTermText").disabled=false;
		document.getElementById("searchButton").disabled=false;
		document.getElementById("detailed_results_checkbox").disabled=false;
		if(typeof(Storage) !== "undefined")
		{
			localStorage.setItem('intro_to_electronics_show_search_results', '-', 1);
		};	
		return;
	};
	// locally store search term
		if(typeof(Storage) !== "undefined") {
			localStorage.setItem('intro_to_electronics_show_search_results', 'ok');
			searchTerm=document.getElementById('searchTermText').value;
			localStorage.setItem('intro_to_electronics_search_term', searchTerm);
		};		
	if(chapter_count==1)
	{
		document.getElementById('search_results_header').innerHTML="Ο όρος <b>"+document.getElementById('searchTermText').value+"</b> εμφανίζεται στο ακόλουθο κεφάλαιο:";
	};
	if(chapter_count>1)
	{
		document.getElementById('search_results_header').innerHTML="Ο όρος <b>"+document.getElementById('searchTermText').value+"</b> εμφανίζεται στα ακόλουθα κεφάλαια:";
	};
	for (i = 0; i < 8; i++) 
	{
		if(searchResultsArray[i]!=-1)
		{
			document.getElementById('term_in_chapter_'+(i+1)).style.display="table-cell";
		}
	};	
	document.getElementById('searchResultsDiv').style.display="block";
	search_error_div.innerHTML="";
	search_error_div.style.color='red';
	
	// display detailed search results
		if(perform_detailed_search==true)
		{
			total_number_of_search_results=0;
			total_number_of_chapters=0;
			for (i = 0; i < numberOfTermOccurrencesArray.length; i++) 
			{
				total_number_of_search_results=total_number_of_search_results+numberOfTermOccurrencesArray[i];
				if(numberOfTermOccurrencesArray[i]>0)
				{
					total_number_of_chapters=total_number_of_chapters+1;
				};
			};  "+total_number_of_search_results+"
			detailed_search_results_div=document.getElementById("detailed_search_results");
			detailed_search_results_div_Content='<hr/><p><b>Ανάλυση αποτελεσμάτων αναζήτησης:</b></p>';
			if(total_number_of_search_results==1 && total_number_of_chapters==1)
			{
				detailed_search_results_div_Content+="<p> Βρέθηκε <b>μία (1)</b> εμφάνιση του πιο πάνω όρου σε <b>ένα (1)</b> κεφάλαιο, ως εξής: </p>";
			};			
			if(total_number_of_search_results>1 && total_number_of_chapters>1)
			{
				detailed_search_results_div_Content+="<p> Βρέθηκαν συνολικά <b>"+total_number_of_search_results+"</b> εμφανίσεις του πιο πάνω όρου σε <b>"+total_number_of_chapters+"</b> κεφάλαια, ως εξής: </p>";
			};
			if(total_number_of_search_results==1 && total_number_of_chapters>1)
			{
				detailed_search_results_div_Content+="<p> Βρέθηκε <b>μία (1)</b> εμφάνιση του πιο πάνω όρου σε <b>"+total_number_of_chapters+"</b> κεφάλαια, ως εξής: </p>";
			};
			if(total_number_of_search_results>1 && total_number_of_chapters==1)
			{
				detailed_search_results_div_Content+="<p> Βρέθηκαν συνολικά <b>"+total_number_of_search_results+"</b> εμφανίσεις του πιο πάνω όρου σε <b>ένα (1)</b> κεφάλαιο, ως εξής: </p>";
			};
			
			detailed_search_results_div_Content+="<table style='border: 1px solid #C2D1FF;'>";
			detailed_search_results_div_Content+="<tr>";
			detailed_search_results_div_Content+="<th style='border: 1px solid #C2D1FF; color: #2E5CE6; background-color: #C2D1FF;'>";
			detailed_search_results_div_Content+="Αριθ. κεφαλαίου";
			detailed_search_results_div_Content+="</th>";
			detailed_search_results_div_Content+="<th style='border: 1px solid #C2D1FF; color: #2E5CE6; background-color: #C2D1FF;'>";
			detailed_search_results_div_Content+="Τίτλος κεφαλαίου";
			detailed_search_results_div_Content+="</th>";
			detailed_search_results_div_Content+="<th style='border: 1px solid #C2D1FF; color: #2E5CE6; background-color: #C2D1FF;'>";
			detailed_search_results_div_Content+="Αριθ. εμφανίσεων";
			detailed_search_results_div_Content+="</th>";
			detailed_search_results_div_Content+="<th style='border: 1px solid #C2D1FF; color: #2E5CE6; background-color: #C2D1FF;'>";
			detailed_search_results_div_Content+="Ποσοστό (%)";
			detailed_search_results_div_Content+="</th>";			
			detailed_search_results_div_Content+="</tr>";
			for (i = 0; i < numberOfTermOccurrencesArray.length; i++) 
			{
				if(numberOfTermOccurrencesArray[i]>0)
				{ 
					detailed_search_results_div_Content+="<tr><td style='border: 1px solid #C2D1FF; text-align:center;'>";
					detailed_search_results_div_Content+="<a href='chapter_0"+(i+1)+".xhtml' title='Μετάβαση στο "+(i+1)+"o κεφάλαιο'>"+(i+1)+"</a>";
					detailed_search_results_div_Content+="</td>";
					
					detailed_search_results_div_Content+="<td style='border: 1px solid #C2D1FF; text-align:center;'>";
					detailed_search_results_div_Content+="<a href='chapter_0"+(i+1)+".xhtml' title='Μετάβαση στο "+(i+1)+"o κεφάλαιο'>"+chapterTitlesArray[i]+"</a>";
					detailed_search_results_div_Content+="</td>";
					
					detailed_search_results_div_Content+="<td style='border: 1px solid #C2D1FF; text-align:center;'>";
					detailed_search_results_div_Content+=numberOfTermOccurrencesArray[i];
					detailed_search_results_div_Content+="</td>";

					detailed_search_results_div_Content+="<td style='border: 1px solid #C2D1FF; text-align:center;'>";
					detailed_search_results_div_Content+=Math.round(10000*(numberOfTermOccurrencesArray[i]/total_number_of_search_results))/100;
					detailed_search_results_div_Content+="</td></tr>";											
				}			
			};	
			detailed_search_results_div_Content+="</table>";
			detailed_search_results_div.innerHTML=detailed_search_results_div_Content;			
		}
	
	document.getElementById("searchTermText").disabled=false;
	document.getElementById("searchButton").disabled=false;
	document.getElementById("detailed_results_checkbox").disabled=false;
	document.body.style.cursor='auto';		
}

function stripAccents(inputString)
{
	inputString=inputString.replaceAll('ά','α');
	inputString=inputString.replaceAll('έ','ε');
	inputString=inputString.replaceAll('ή','η');
	inputString=inputString.replaceAll('ί','ι');
	inputString=inputString.replaceAll('ϊ','ι');
	inputString=inputString.replaceAll('ΐ','ι');
	inputString=inputString.replaceAll('ό','ο');
	inputString=inputString.replaceAll('ύ','υ');
	inputString=inputString.replaceAll('ϋ','υ');
	inputString=inputString.replaceAll('ΰ','υ');
	inputString=inputString.replaceAll('ώ','ω');
	inputString=inputString.replaceAll('Ά','Α');
	inputString=inputString.replaceAll('Έ','Ε');
	inputString=inputString.replaceAll('Ή','Η');
	inputString=inputString.replaceAll('Ί','Ι');
	inputString=inputString.replaceAll('Ϊ','Ι');
	inputString=inputString.replaceAll('Ό','Ι');
	inputString=inputString.replaceAll('Ύ','Υ');
	inputString=inputString.replaceAll('Ϋ','Υ');
	inputString=inputString.replaceAll('Ώ','Ω');
	return inputString;
}

String.prototype.replaceAll = function (find, replace) {
    var str = this;
    return str.replace(new RegExp(find.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&'), 'g'), replace);
};

function hideSearchResultsBrowser() {
	searchBrowser_div=document.getElementById('searchBrowser_div');
	searchBrowser_div.style.display='none';
	if(typeof(Storage) !== "undefined") {
		localStorage.setItem('intro_to_electronics_show_search_results', '-'); // hide results till next search
	};
}

function showSearchResultsBrowser() { 
	if(checkIfSettingEnabled(5)) //search option is enabled, or default settings apply
	{
		if(typeof(Storage) !== "undefined") {
			show_search_results=localStorage.getItem('intro_to_electronics_show_search_results');
			if (show_search_results=='ok')
			{
				current_search_term=localStorage.getItem('intro_to_electronics_search_term');
				searchForTermRemote(current_search_term);
			};
		};
	};
}

function showSearchResultsRemote(){
	if(ajaxResponseReadyArray.indexOf(0)!=-1){return}; // return if not all ajax responses are collected
	clearInterval(setIntervalValRemote); // stop waiting
	searchBrowser_container=document.getElementById('searchResultsBrowser_container');
	searchBrowser_div_element=document.getElementById('searchBrowser_div');
	searchBrowser_div_element.onmouseover=function(){
		document.getElementById('searchBrowser_div').style.opacity="1";
		document.getElementById('searchBrowser_div').style.filter="alpha(opacity=100)";
	};
	searchBrowser_div_element.onmouseout=function(){
		document.getElementById('searchBrowser_div').style.opacity="0.85";
		document.getElementById('searchBrowser_div').style.filter="alpha(opacity=85)";
	};
		
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<img src="'+highlight_Image.src+'" class="toolbutton" onclick="highlightTerm(-1);" title="Επισήμανση όλων" />';
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<img src="'+no_highlight_Image.src+'" class="toolbutton" onclick="removeTermHighlight();" title="Απόκρυψη επισήμανσης" />';
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<img src="'+search_goto_previous_Image.src+'"   class="toolbutton" onclick="goToPreviousHighlight();" title="Μετάβαση στην προηγούμενη εμφάνιση" />';
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<img src="'+search_goto_next_Image.src+'"   class="toolbutton" style="margin-right:5px;" onclick="goToNextHighlight();" title="Μετάβαση στην επόμενη εμφάνιση" />';
	
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<div id="HighlightNumberIndicator" style="display:none;"> (<span id="CurrentHighlightNumberText"></span> / <span id="TotalHighlightNumberText"></span>)</div>';	
	
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<p id="search_results_first_par_ID" style="text-align:left;">Όρος πρόσφατης αναζήτησης: <b id="search_term_text_ID" style="cursor:pointer;" title="'+current_search_term+'">'+truncateLongTerm(current_search_term, 19)+'</b></p>'; 
	
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<p id="search_results_second_par_ID" style="text-align:left; margin-top:-5px;"></p>';
	
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<p id="search_results_third_par_ID" style="text-align:left; margin-top:-5px;"></p>';
	
	searchBrowser_container.innerHTML=searchBrowser_container.innerHTML+'<p id="search_results_fourth_par_ID" style="text-align:left; margin-top:-5px;"></p>';

	initializeTermHighlighting(current_search_term);
}

function initializeTermHighlighting(searchTerm){
	highlightElementIdArray=[];
	//avoid marking search terms multiple times
		$(".searchTermHighlight").contents().unwrap(); 
		$(".searchTermHighlight").remove();
	searchTermOriginal=searchTerm;
	searchTerm=searchTerm.myLowerCase(); // to lowercase
	searchTerm=stripAccents(searchTerm); // Remove accents
	searchTerm = searchTerm.replace(/[&\/\\#,+()$~%.'":*?<>{}]/g, ''); // remove special chars
	var divs_to_exclude=['current_section','next_section','previous_section','search_term_text_ID','search_results_first_par_ID','search_results_second_par_ID','search_results_third_par_ID','search_results_fourth_par_ID','tocTitleID'];
	$('body, body *')
	.contents()
	.filter(function() {
		return this.nodeType == Node.TEXT_NODE
			&& stripAccents(this.nodeValue.myLowerCase()).indexOf(searchTerm) >= 0;
	}).each(function() {
		var dummy = $('<b>');
		if(divs_to_exclude.indexOf(this.parentNode.id)==-1 && this.parentNode.className!='fancyLink')
		{
			this.parentNode.replaceChild(dummy[0], this);
			var matchArray=this.nodeValue.match(makeRegularExpression(searchTermOriginal));
			var replacement_string=this.nodeValue;
			for(i=0;i<matchArray.length;i++)
			{
				match_reg_exp = new RegExp('('+matchArray[i]+')(?!<\/span)', "g");
				replacement_string=replacement_string.replace(match_reg_exp,"<span class='searchTermHighlight'>"+matchArray[i]+"</span>");
			}
			dummy.replaceWith(replacement_string);		
		};	
	});
	totalHighlights=document.getElementsByClassName('searchTermHighlight').length;
	document.getElementById("TotalHighlightNumberText").innerHTML=totalHighlights;
	if(currentHighlightIndex===undefined){currentHighlightIndex=-1000;};	
	highlighted_term_elements=document.getElementsByClassName("searchTermHighlight");
	for (i = 0; i < highlighted_term_elements.length; i++) 
	{
		highlighted_term_elements[i].id='highlighted_term_element_'+i;
		highlightElementIdArray[i]=highlighted_term_elements[i].id;
	};
	searchBrowser_div=document.getElementById('searchBrowser_div');
	// fill results div content
		second_par_element=document.getElementById("search_results_second_par_ID");
		third_par_element=document.getElementById("search_results_third_par_ID");
		fourth_par_element=document.getElementById("search_results_fourth_par_ID");
		fourth_par_element.innerHTML='';
		if(totalHighlights==1)
		{
			second_par_element.innerHTML='Βρέθηκε μία (1) εμφάνιση σε αυτό το κεφάλαιο.';
		}
		else
		{
			if(totalHighlights==0)
			{
				second_par_element.innerHTML='Δεν βρέθηκαν εμφανίσεις σε αυτό το κεφάλαιο.';
			}
			else
			{
				second_par_element.innerHTML='Βρέθηκαν '+totalHighlights+' εμφανίσεις σε αυτό το κεφάλαιο.';
			};		
		};
		current_chapter_number=parseInt(document.getElementsByClassName("chapter_number")[0].innerHTML,10);
		var chapters_Array=[];
		for (i = 0; i < 8; i++) 
		{
			if(searchResultsArray[i]!=-1)
			{
				chapters_Array.push(i+1);
			};
		};	
		if(chapters_Array.length>0)
		{
			if(chapters_Array.indexOf(current_chapter_number)==-1)
			{
				if(chapters_Array.length==1)
				{
					third_par_element.innerHTML='Ο όρος εμφανίζεται στo κεφάλαιo:';
				}
				else
				{
					third_par_element.innerHTML='Ο όρος εμφανίζεται στα κεφάλαια:';
				};			
			}
			else
			{
				if(chapters_Array.length>1)
				{
					if(chapters_Array.length==2)
					{
						third_par_element.innerHTML='Ο όρος εμφανίζεται, επίσης, στo κεφάλαιo:';
					}
					else
					{
						third_par_element.innerHTML='Ο όρος εμφανίζεται, επίσης, στα κεφάλαια:';
					};					
				};							
			};
			for (i = 0; i < 8; i++) 
			{
				if(searchResultsArray[i]!=-1)
				{
					if((i+1)!=current_chapter_number)
					{
						fourth_par_element.innerHTML=fourth_par_element.innerHTML+'<a title="Μετάβαση στο '+(i+1)+'ο κεφάλαιο"  href="chapter_0'+(i+1)+'.xhtml">'+(i+1)+'</a>  ';				
					};
				};
			};		
		};	
	
	searchBrowser_div.style.display='inline-block';
	// move up if footnote is hidden
		footnote_div=document.getElementById('footnote_div');
		if(footnote_div.style.display!='inline-block')
		{
			$("#searchBrowser_div").css("top","0");
			$("#searchBrowser_div").css("left","0");				
		}
		else
		{
			$("#searchBrowser_div").css("top","315px");
			$("#searchBrowser_div").css("left","0");				
		};
	// make draggable
		$("#searchBrowser_div").draggable({
			containment: "window",
			cursor: "move",
			scroll: false,
			zIndex: 101
			});	
	// move footnote to top left corner, if open
		if($("#footnote_div").css("display")!='none')
		{
			$("#footnote_div").css("top","0");
			$("#footnote_div").css("left","0");			
		};
	// if footnotes window is open, move on top when clicked
		$("#searchBrowser_div").click(
			function(){
				if($("#footnote_div").css("display")!='none')
				{
					$("#footnote_div").css("z-index",99);
					$("#searchBrowser_div").css("z-index",100);
				};
			}
		);
};


function highlightTerm(termIndex){
	if(totalHighlights==0){return};
	removeTermHighlight();
	initializeTermHighlighting(current_search_term); // initialize again, since term highlights may have been removed due to user highlighting text
	if(termIndex==-1) //highlight all
	{
		highlighted_term_elements=document.getElementsByClassName("searchTermHighlight");
		for (i = 0; i < highlighted_term_elements.length; i++) 
		{
			highlighted_term_elements[i].className='searchTermHighlight searchTermHighlightVisible';
		};			
	}
	else
	{
		document.getElementById(highlightElementIdArray[termIndex]).className='searchTermHighlight searchTermHighlightVisible';
	};
}

function removeTermHighlight(){
	if(totalHighlights==0){return};
	highlighted_term_elements=document.getElementsByClassName("searchTermHighlight");
	for (i = 0; i < highlighted_term_elements.length; i++) 
	{
		highlighted_term_elements[i].className='searchTermHighlight';
	};
}

function makeRegularExpression(termString){
	termString=termString.myLowerCase();
	result=stripAccents(termString).replaceAll('α','(α|ά|Α|Ά)');
	result=result.replaceAll('ε','(ε|έ)');
	result=result.replaceAll('η','(η|ή)');
	result=result.replaceAll('ι','(ι|ί|ϊ|ΐ)');
	result=result.replaceAll('ο','(ο|ό)');
	result=result.replaceAll('υ','(υ|ύ|ϋ|ΰ)');
	result=result.replaceAll('ω','(ω|ώ)');
	result = new RegExp(result, "gi");
	return result;
}

function goToNextHighlight(){
	if(totalHighlights==0){return};
	if(currentHighlightIndex<0)
	{
		currentHighlightIndex=0;
	}
	else
	{
		currentHighlightIndex=currentHighlightIndex+1;
	};	
	if(currentHighlightIndex>totalHighlights-1){currentHighlightIndex=0};
	highlightTerm(currentHighlightIndex);
	document.getElementById("CurrentHighlightNumberText").innerHTML=currentHighlightIndex+1;
	scrollOffset=$(window).height()/2;
	    $('html, body').animate({
        scrollTop: $('#'+highlightElementIdArray[currentHighlightIndex]).offset().top-scrollOffset
    }, 0);	
	document.getElementById("HighlightNumberIndicator").style.display="inline-block";
}

function goToPreviousHighlight(){
	if(totalHighlights==0){return};
	if(currentHighlightIndex==-1000)
	{
		currentHighlightIndex=totalHighlights-1;
	}
	else
	{
		currentHighlightIndex=currentHighlightIndex-1;
	};	
	if(currentHighlightIndex<0){currentHighlightIndex=totalHighlights-1};
	highlightTerm(currentHighlightIndex);
	document.getElementById("CurrentHighlightNumberText").innerHTML=currentHighlightIndex+1;
	scrollOffset=$(window).height()/2;
	    $('html, body').animate({
        scrollTop: $('#'+highlightElementIdArray[currentHighlightIndex]).offset().top-scrollOffset
    }, 0);
	document.getElementById("HighlightNumberIndicator").style.display="inline-block";	
}

function toggleDetailedResults(){
	checkbox_element=document.getElementById("detailed_results_checkbox");
	if(checkbox_element.value=="false")
	{
		checkbox_element.value="true";
		checkbox_element.checked=true;
		perform_detailed_search=true;
	}
	else
	{
		checkbox_element.value="false";
		checkbox_element.checked=false;
		perform_detailed_search=false;		
	};
}

function initializeCheckbox(){
	if(checkIfSettingEnabled(5)) //search is enabled
	{	
		document.getElementById("detailed_results_checkbox").checked=false;
	};
}

function truncateLongTerm(termString, number_of_chars){
	if(termString.length>number_of_chars)
	{
		resultString=termString.substr(0,number_of_chars-4)+" ...";
	}
	else
	{
		resultString=termString;
	};
	return resultString;
}

String.prototype.myLowerCase = function () {
    result_str=this.toLowerCase();
	result_str=result_str.replaceAll('σ ','ς');
	return result_str;
};

