// Created by John Liaperdos - August 16, 2015
// Modified: August 27, 2015  

// preload images
	var close_button_Image=new Image();
    close_button_Image.src="../images/misc/close_button.png"; 

var inChapterTocLinksArray=[];
var tocLinkDistancesfromTopArray=[];
var tocAutoScroll=false;

$(document).ready(function(){
	if(checkIfSettingEnabled(4)) //chapter TOC option is enabled, or default settings apply
	{		
		var current_section_element=document.getElementById('current_section');
		current_section_element.style.cursor='pointer';
		current_section_element.title='Πίνακας περιεχομένων κεφαλαίου';
		current_section_element.onclick=function(){showChapterToc();};
		createChapterToc();
	};
}); 

function createChapterToc(){
	var chapter_toc_div=document.createElement('div');
	chapter_toc_div.id='chapter_toc_window';
	chapter_toc_div.className='chapter_toc';
	chapter_toc_div.style.visibility='hidden';
	var chapter_toc_drag_handle_div=document.createElement('div');
	chapter_toc_drag_handle_div.id="chapterTocDragHandle";
	chapter_toc_drag_handle_div.style.height="25px";
	chapter_toc_drag_handle_div.style.width="100%";
	var toc_hide_button=document.createElement('img');
	toc_hide_button.id='tocHideButtonID';
	toc_hide_button.className='noScalePNGs';
	toc_hide_button.src=close_button_Image.src;
	toc_hide_button.alt='';
	toc_hide_button.style.width="25px";
	toc_hide_button.style.height="25px";
	toc_hide_button.style.cursor="pointer";
	toc_hide_button.style.position="absolute";
	toc_hide_button.style.right="3px";
	toc_hide_button.onclick=function(){
		document.getElementById('chapter_toc_window').style.visibility="hidden";
	};
	var toc_text_area=document.createElement('div');
	toc_text_area.id="tocTextAreaID";
	toc_text_area.style.marginTop="0px";
	toc_text_area.style.marginRight="0px";
	toc_text_area.style.marginLeft="20px";
	toc_text_area.style.marginBottom="10px";
	toc_text_area.style.height="95%";
	toc_text_area.style.overflow="auto";
	toc_text_area.style.fontSize="14px";
	var chapter_number=document.getElementsByClassName("chapter_number")[0].innerHTML;
	var chapter_title=document.getElementById("width_measurement").innerHTML;
	toc_text_area.innerHTML+='<span style="display:table; margin:0 auto;"><b>ΠΕΡΙΕΧΟΜΕΝΑ</b></span>'; 
	toc_text_area.innerHTML+='<span style="display:table; margin:0 auto; text-align:center;"><b id="tocTitleID">Κεφάλαιο '+chapter_number+': '+chapter_title+'</b></span>';
	toc_text_area.innerHTML+='<hr/>';
	// get TOC contents
		var count_TOC_entries=0;
		//sections
			var section_elements=document.body.querySelectorAll('h2.section, h2.subsection, h2.subsubsection');
			var section_entry;
			for(i=0;i<section_elements.length;i++)
			{
				if(section_elements[i].className=='section')
				{
					section_entry='<a id="inChapterTocLink-'+i+'" style="display:block" class="fancyLink" href="#'+section_elements[i].id+'">'+section_elements[i].innerHTML+'</a>';
				};
				if(section_elements[i].className=='subsection')
				{
					section_entry='<a id="inChapterTocLink-'+i+'" style="display:block; margin-left:23px;" class="fancyLink" href="#'+section_elements[i].id+'">'+section_elements[i].innerHTML+'</a>';
				};
				if(section_elements[i].className=='subsubsection')
				{
					section_entry='<a id="inChapterTocLink-'+i+'" style="display:block; margin-left:46px;" class="fancyLink" href="#'+section_elements[i].id+'">'+section_elements[i].innerHTML+'</a>';
				};						
				toc_text_area.innerHTML+=section_entry;				
				inChapterTocLinksArray[count_TOC_entries]=section_elements[i].id;
				count_TOC_entries+=1;
			};
		//exercises
			var exercises_element=document.body.querySelectorAll('section.exercises');
			if(exercises_element.length==1)
			{
				section_entry='<a id="inChapterTocLink-'+count_TOC_entries+'" style="display:block" class="fancyLink" href="#'+exercises_element[0].id+'"><i>Κριτήρια αξιολόγησης</i></a>';
				toc_text_area.innerHTML+=section_entry;
				inChapterTocLinksArray[count_TOC_entries]=exercises_element[0].id;
				count_TOC_entries+=1;				
			};
		// bibliography
			var bibliography_element=document.body.querySelectorAll('section.bibliography');
			section_entry='<a id="inChapterTocLink-'+count_TOC_entries+'" style="display:block" class="fancyLink" href="#'+bibliography_element[0].id+'"><i>Βιβλιογραφία</i></a>';
			toc_text_area.innerHTML+=section_entry;
			inChapterTocLinksArray[count_TOC_entries]=bibliography_element[0].id;
			count_TOC_entries+=1;
		// interactive
			var interactive_element=document.body.querySelectorAll('section.interactive');
			if(interactive_element.length==1)
			{
				section_entry='<a id="inChapterTocLink-'+count_TOC_entries+'" style="display:block" class="fancyLink" href="#'+interactive_element[0].id+'"><i>Διαδραστικά στοιχεία</i></a>';
				toc_text_area.innerHTML+=section_entry;
				inChapterTocLinksArray[count_TOC_entries]=interactive_element[0].id;
				count_TOC_entries+=1;				
			};
		// media (videos)
			var media_element=document.body.querySelectorAll('section.media');
			if(media_element.length==1)
			{
				section_entry='<a id="inChapterTocLink-'+count_TOC_entries+'" style="display:block" class="fancyLink" href="#'+media_element[0].id+'"><i>Οπτικοακουστικό υλικό</i></a>';
				toc_text_area.innerHTML+=section_entry;
				inChapterTocLinksArray[count_TOC_entries]=media_element[0].id;
				count_TOC_entries+=1;				
			};		
	// add to DOM
		chapter_toc_drag_handle_div.appendChild(toc_hide_button);
		chapter_toc_div.appendChild(chapter_toc_drag_handle_div);	
		chapter_toc_div.appendChild(toc_text_area);
		document.body.appendChild(chapter_toc_div);
	// make draggable
		$("#chapter_toc_window").draggable({
			containment: "window",
			cursor: "move",
			scroll: false,
			zIndex: 201,
			handle: $("#chapterTocDragHandle")
			});
	// add effect
		$('#chapter_toc_window').hover(chapterTocMouseEnter, chapterTocMouseLeave);
	// automatically highlight headers in ToC when page scrolls
		setInterval(highlightChapterTocOnScroll,2000);
	// show TOC at page load
		setTimeout(showChapterToc,5000);
}

function highlightChapterTocOnScroll(){
	var chapter_toc_window_element=document.getElementById('chapter_toc_window');
	if (chapter_toc_window_element.style.visibility=='visible' && tocAutoScroll==true)
	{		
		var count_color_changes=0;
		for(i=inChapterTocLinksArray.length-1;i>=0;i--)
		{
			var sectionID;
			if($('#'+inChapterTocLinksArray[i]).hasClass('section') || $('#'+inChapterTocLinksArray[i]).hasClass('subsection') || $('#'+inChapterTocLinksArray[i]).hasClass('subsubsection'))
			{
				sectionID="visibility_check_"+inChapterTocLinksArray[i].substr(8); //normal section
			}
			else
			{
				sectionID=inChapterTocLinksArray[i]; //bibliography, interactive, etc.
			};
			if(sectionVisible(sectionID)==true)
			{
				count_color_changes+=1;
				//change background color and focus
					if(count_color_changes==1) //bottom-most visible section
					{
						document.getElementById('inChapterTocLink-'+i).style.borderStyle="solid";
						document.getElementById('inChapterTocLink-'+i).style.borderColor="blue";
						document.getElementById('inChapterTocLink-'+i).style.background="white";
						//get focus in TOC
							var scroll_position=tocLinkDistancesfromTopArray[i]-90; 
							$('#tocTextAreaID').scrollTop(scroll_position);	
					}
					else
					{
						document.getElementById('inChapterTocLink-'+i).style.background="white";
						document.getElementById('inChapterTocLink-'+i).style.borderStyle="none";
					};
			}
			else
			{
				document.getElementById('inChapterTocLink-'+i).style.background="transparent";
				document.getElementById('inChapterTocLink-'+i).style.borderStyle="none";
			};
		};
		if(count_color_changes==0)
		{
			$('#tocTextAreaID').scrollTop(0); //just scroll to top
		};		
	};
}

function showChapterToc(){
	// store entry positions in TOC window
		for(i=0;i<inChapterTocLinksArray.length;i++)
			{
				tocLinkDistancesfromTopArray[i]=$('#inChapterTocLink-'+i).position().top;
			};	
	tocAutoScroll=false;
	var chapter_toc_window_element=document.getElementById('chapter_toc_window');
	$('#tocTextAreaID').scrollTop(0);	// scroll TOC to top
	chapter_toc_window_element.style.visibility="visible";
	//start auto-scrolling after a while
		setTimeout(function(){tocAutoScroll=true;},10000);
}

function chapterTocMouseEnter(){
	document.getElementById('chapter_toc_window').style.opacity="1";
	document.getElementById('chapter_toc_window').style.filter="alpha(opacity=100)";
	tocAutoScroll=false;
	// remove highlights
		for(i=inChapterTocLinksArray.length-1;i>=0;i--)
		{
			document.getElementById('inChapterTocLink-'+i).style.background="transparent";
			document.getElementById('inChapterTocLink-'+i).style.borderStyle="none";
		};	
}

function chapterTocMouseLeave(){
	document.getElementById('chapter_toc_window').style.opacity="0.7";
	document.getElementById('chapter_toc_window').style.filter="alpha(opacity=70)";
	tocAutoScroll=true;
}


function sectionVisible(chapter_id){
	var win = $(window);

	var viewport = {
		top : win.scrollTop(),
		left : win.scrollLeft()
	};
	viewport.right = viewport.left + win.width();
	viewport.bottom = viewport.top + win.height();
	
	if($("#floatdiv").hasClass("floatdiv_horizontal")) //subtract horizontal menu's height
	{
		viewport.bottom = viewport.bottom - 55;
	};
	
	var height = $('#'+chapter_id).outerHeight()-50; //offset to allow some "separation" between chapters
	var width = $('#'+chapter_id).outerWidth();

	if(!width || !height){
		return false;
	}

	var bounds = $('#'+chapter_id).offset();
	bounds.right = bounds.left + width;
	bounds.bottom = bounds.top + height;

	var visible = (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));

	return visible;
		
}


