// Created by John Liaperdos - August 25, 2015
// Modified: -

var systemFontSearchInterval;
var count_search_iterations;
var book_current_font_family;
var selected_font_family;

function initializeFontSelection(){
	count_search_iterations=0
	selected_font_family="ClearSans";
	//find user-defined font
		var font_family_cookie=getCookie("intro_to_electronics_font_family");
		if(font_family_cookie=="")
		{
			book_current_font_family="ClearSans"; //default font-family
		}
		else
		{
			book_current_font_family=font_family_cookie;
		};
	// show current font in page
		$("#current_font_family_span").html(book_current_font_family);
		$("#current_font_family_span").css("font-family", book_current_font_family);
		updateFontsOnPage(selected_font_family);
	//reload flash object
		$("#fontListSWF").html($("#fontListSWF").html());
	$("#font_change_message_area").html("Εκτελείται αναζήτηση των γραμματοσειρών του συστήματός σας ...");
	systemFontSearchInterval=setInterval(systemFontsSearchCheck,1000);
}

function updateFontsOnPage(font_family_name){
	$("#sample_text_paragraphs").css("font-family", font_family_name);
	$("#font_change_message_area").html("Επιλεγμένη γραμματοσειρά: <b style='font-family:"+font_family_name+";'>"+font_family_name+"</b>. Βεβαιωθείτε πως η γραμματοσειρά την οποία επιλέξατε είναι κατάλληλη για τη σωστή απεικόνιση του κειμένου και πατήστε <b>εφαρμογή</b>, αν θέλετε να την χρησιμοποιήσετε.");	
}

function systemFontsSearchCheck(){	
	count_search_iterations++;
	if(count_search_iterations>15)
	{
		clearInterval(systemFontSearchInterval);
		$("#font_change_message_area").html("Δεν βρέθηκαν γραμματοσειρές συστήματος. Μπορείτε να επιλέξετε μόνο γενικές γραμματοσειρές.");
		$("#system_font_selector").prop("disabled",true);
		$("#system_font_dropdown").prop("disabled",true);
		$("#no_system_fonts_found").html("Δεν βρέθηκαν γραμματοσειρές");
	}
	else
	{
		if($("#system_font_dropdown").html().indexOf('Αναζήτηση ...')==-1)
		{
			clearInterval(systemFontSearchInterval);
			$("#font_change_message_area").html("Η αναζήτηση γραμματοσειρών συστήματος ολοκληρώθηκε.");
		}
	};			
}

function populateFontList(fontArr)
{	
	for (var key in fontArr)
	{
		var regularFontsCounter=0;
		var fontName = fontArr[key];		
		// trim
			fontName = fontName.replace(/^\s\s*/, '').replace(/\s\s*$/, '');		
		if (!fontName.match(/[_\-\s]Italic$/)
			&& !fontName.match(/[_\-\s](Demi)?[Bb]old$/)
			&& !fontName.match(/[_\-\s]Medium$/)
			&& !fontName.match(/[_\-\s](Ultra)?[Ll]ight$/)
			&& !fontName.match(/[_\-\s]Condensed$/)
			&& !fontName.match(/[_\-\s]Thin$/)
			)
				{
					regularFontsCounter++;
					fontName = fontName.replace(/\s*Regular$/, '');
					if(regularFontsCounter==1)
					{
						$("#no_system_fonts_found").remove();
					};
					$("#system_font_dropdown").append("<option>"+fontName+"</option>");					
				};		
	};
}

function updateTextSample(action_code){
	if(action_code==0) //default font family
	{
		selected_font_family="ClearSans";
	};
	if(action_code==1) //generic font family
	{
		$("#system_font_selector").prop("checked", false);
		$("#default_font_selector").prop("checked", false);
		$("#generic_font_selector").prop("checked", true);		
		var generic_font_dropdown_option=document.getElementById("generic_font_dropdown");
		selected_font_family=generic_font_dropdown_option.options[generic_font_dropdown_option.selectedIndex].text;		
	};	
	if(action_code==2) //system font family
	{		 
		$("#default_font_selector").prop("checked", false);
		$("#generic_font_selector").prop("checked", false);	
		$("#system_font_selector").prop("checked", true);
		var system_font_dropdown_option=document.getElementById("system_font_dropdown");
		selected_font_family=system_font_dropdown_option.options[system_font_dropdown_option.selectedIndex].text;			 
	};	
	$("#sample_text_paragraphs").css("font-family", selected_font_family);
	updateFontsOnPage(selected_font_family);
}

function applyFontChanges(){
	setCookie("intro_to_electronics_font_family", selected_font_family, 365);
	$("#current_font_family_span").html(selected_font_family);
	$("#current_font_family_span").css("font-family", selected_font_family);
	$("#font_change_message_area").html("Η επιλογή της γραμματοσειράς <span id='selected_font_text'>"+selected_font_family+"</span> ολοκληρώθηκε με επιτυχία.");
	$("#selected_font_text").css("font-family", selected_font_family);
	$("#selected_font_text").css("font-style", "italic");
	$("#selected_font_text").css("font-weight", "bold");
	book_current_font_family=selected_font_family;
}

////////////////////////
// set chapter fonts ///
////////////////////////

function setChapterFont(){	
	var chapter_current_font_family;
	//get font from stored cookie, if exists
		var font_family_cookie=getCookie("intro_to_electronics_font_family");
		if(font_family_cookie=="")
		{
			chapter_current_font_family="ClearSans"; //default font-family
		}
		else
		{
			chapter_current_font_family=font_family_cookie;
		};
	//apply font family to the whole document (menus maintain the default font, through CSS)
		$("body").css("font-family",chapter_current_font_family);
}





