// Created by John Liaperdos - April 2015
// Modified: July 26, 2015

var setting = new Array();

checkJavascriptSupport();

function checkJavascriptSupport() {
	/* check if the reading system supports the needed scripting */
		setting['scriptEnabled'] =false;
		setting['webBrowserOrEpub2'] =false;
		if (typeof navigator.epubReadingSystem != "undefined")
			{
				setting['scriptEnabled'] = (
				!navigator.epubReadingSystem.hasFeature('dom-manipulation')
				) ? false : true;					
			}
			else
			{
				setting['scriptEnabled'] =true; // epub2 case, or reader software that does not provide "epubReadingSystem"
				setting['webBrowserOrEpub2'] =true;
			};
};

function showInteractiveSection() {
	checkJavascriptSupport();
	/* exit if the reading system does not support scripting */
		if (!setting['scriptEnabled']) { return; }
	/* Show interactive parts*/
		document.getElementById('interactive_elements_check').innerHTML="";	
		document.getElementById('interactive_elements_list').style.visibility='visible';	
}

		
