// Created by John Liaperdos - June 19, 2015
// Modified: September 11, 2015

// preload images
	var remove_highlight_active_Image=new Image();
    remove_highlight_active_Image.src="../images/misc/remove_highlight_active.png";
	var question_mark_Image=new Image();
    question_mark_Image.src="../images/misc/question_mark.png";
	var remove_highlight_Image=new Image();
    remove_highlight_Image.src="../images/misc/remove_highlight.png";
	var remove_highlight_inactive_Image=new Image();
    remove_highlight_inactive_Image.src="../images/misc/remove_highlight_inactive.png";
	var red_indicator_Image=new Image();
    red_indicator_Image.src="../images/misc/red_indicator.png";
	var green_indicator_Image=new Image();
    green_indicator_Image.src="../images/misc/green_indicator.png";
	var delete_user_notes_Image=new Image();
    delete_user_notes_Image.src="../images/misc/delete_user_notes.png";	
	var user_notes_Image=new Image();
    user_notes_Image.src="../images/misc/user_notes.png";
	var user_notes_disabled_Image=new Image();
    user_notes_disabled_Image.src="../images/misc/user_notes_disabled.png";
	var save_Image=new Image();
    save_Image.src="../images/misc/save.png";

var enable_math=true;
var user_notes_previous_value='';

/////////////////////////////
// personal reader notes:  //
/////////////////////////////

function handleUserNotes(chapterName) {
	if(checkIfSettingEnabled(8)) //user notes saved in Google Drive
	{
		// load existing notes
			var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
			if(google_script_URL==''){return};
			var chapterNumber=parseInt($('span.chapter_number').first().html(),10);
			$.post(google_script_URL, {mode: "getValue", cellID: String.fromCharCode(65 + chapterNumber)+"1"}, 
				function(data, status){
					if(status!="success") {return};
					var stored_notes=LZString.decompressFromUTF16(data);
					if (stored_notes === null || stored_notes == 'null' || stored_notes=='') 
					{
						document.getElementById('user_note_message_div').style.display="inline-block";
						document.getElementById('delete_user_notes_button').style.display="none";
						document.getElementById('save_user_notes_button').style.display="none";
					}
					else
					{
						originallocalStorageContent=stored_notes;
						stored_notes=removeMathjaxSVG(stored_notes);
						$('#user_notes_list').html(stored_notes);
						$("li.userNoteListItem").css("border-style", "none");
						document.getElementById('user_note_message_div').style.display="none";
						document.getElementById('delete_user_notes_button').style.display="inline-block";
						document.getElementById('save_user_notes_button').style.display="inline-block";	
						// apply alternating color
							colorUserNotes();						
					};					
				}						
			);			

		// store changes periodically if notes are enabled
			if(checkIfSettingEnabled(1)) //user notes are enabled
			{		
				setInterval(function() {
					//store only if changes have been made
						if(user_notes_previous_value==document.getElementById('user_notes_list').innerHTML){return;};
					var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
					if(google_script_URL==''){return};	
					var chapterNumber=parseInt($('span.chapter_number').first().html(),10);					
					$.post(google_script_URL, {cellID: String.fromCharCode(65 + chapterNumber)+"1", cellContent: LZString.compressToUTF16(cleanupMathJax(document.getElementById('user_notes_list').innerHTML)), mode:"setValue"});
					user_notes_previous_value=document.getElementById('user_notes_list').innerHTML;
					}, 3000);
			};
		
	}
	else //user notes saved in Local Storage
	{
		if(typeof(Storage) !== "undefined") 
		{
			// load existing notes
				var localStorageContent=localStorageGetDeCompress('intro_to_electronics_user_notes_'+chapterName);
				if (localStorageContent === null || localStorageContent == 'null' || localStorageContent=='') 
				{
					document.getElementById('user_note_message_div').style.display="inline-block";
					document.getElementById('delete_user_notes_button').style.display="none";
					document.getElementById('save_user_notes_button').style.display="none";
				}
				else
				{
					originallocalStorageContent=localStorageContent;
					localStorageContent=removeMathjaxSVG(localStorageContent);
					$('#user_notes_list').html(localStorageContent);
					$("li.userNoteListItem").css("border-style", "none");
					document.getElementById('user_note_message_div').style.display="none";
					document.getElementById('delete_user_notes_button').style.display="inline-block";
					document.getElementById('save_user_notes_button').style.display="inline-block";				
				};
			// store changes periodically if notes are enabled
				if(checkIfSettingEnabled(1)) //user notes are enabled
				{		
					setInterval(function() {
						//store only if changes have been made
							if(user_notes_previous_value==document.getElementById('user_notes_list').innerHTML){return;};
						localStorageSetCompress('intro_to_electronics_user_notes_'+chapterName, cleanupMathJax(document.getElementById('user_notes_list').innerHTML));
						user_notes_previous_value=document.getElementById('user_notes_list').innerHTML;
						}, 3000);
				};
			// apply alternating color
				colorUserNotes();
		} 
		else 
		{
			document.getElementById('user_note_message_div').style.display="inline-block";
			document.getElementById('user_note_message_div').innerHTML="Δεν υποστηρίζονται";
		};
		if(!checkIfSettingEnabled(1)) //user notes are disabled
		{
			// 'add note' button is disabled
				$('#add_user_note_button').attr('src',user_notes_disabled_Image.src);
			// make existing notes non-editable
				$('#user_notes_list').find("li").find("p").removeAttr("contenteditable").end().end();
		};		
	};
}

function addUserNote() {
	if(checkIfSettingEnabled(1)) //user notes are enabled, or default settings apply
	{		
		if(typeof(Storage) == "undefined") {return};
		document.getElementById('user_note_message_div').style.display="none";
		document.getElementById('delete_user_notes_button').style.display="inline-block";
		document.getElementById('save_user_notes_button').style.display="inline-block";
		// find id of last note and use the next for the new note. If no note exists, start from 1.
			if($("li.userNoteListItem").last().length>0)
			{
				var new_note_id=parseInt($("li.userNoteListItem").last().attr("id").substring(9),10)+1;
			}
			else
			{
				var new_note_id=1;
			};		
		// create new note
			var newUserNote = document.createElement("li");
			newUserNote.setAttribute('class','userNoteListItem');
			newUserNote.setAttribute('id','userNote_'+new_note_id);
			// create individual note links for deleting and typesetting math
				var newDeleteTextSpan = document.createElement("span");
				if(enable_math){var newRerenderTextSpan = document.createElement("span");};
				var newNoteTextPar = document.createElement("p");
				newNoteTextPar.setAttribute('style',"padding-bottom:5px;border-style: solid;border-top:none;border-right:none;border-left:none;border-bottom: dotted gray;");
				newDeleteTextSpan.setAttribute('class','delete_user_note');
				if(enable_math){newRerenderTextSpan.setAttribute('class','rerender_user_note');};
				newDeleteTextSpan.setAttribute('onclick','deleteUserNote('+new_note_id+');');
				if(enable_math){newRerenderTextSpan.setAttribute('onclick','rerenderUserNote('+new_note_id+');');};
				newNoteTextPar.setAttribute("contenteditable",true);
				dateVar = new Date();
				newNoteTextPar.innerHTML="<i>("+padDateTimeString(dateVar.getDate())+"-"+padDateTimeString(dateVar.getMonth()+1)+"-"+dateVar.getFullYear()+", "+padDateTimeString(dateVar.getHours())+":"+padDateTimeString(dateVar.getMinutes())+":"+padDateTimeString(dateVar.getSeconds())+")</i> νέα σημείωση";
				newDeleteTextSpan.innerHTML="[Διαγραφή σημείωσης]";
				if(enable_math){newRerenderTextSpan.innerHTML="[Στοιχειοθεσία μαθηματικών] ";};
				newUserNote.appendChild(newNoteTextPar);
				if(enable_math){newUserNote.appendChild(newRerenderTextSpan);};
				newUserNote.appendChild(newDeleteTextSpan);
		// append note to document
			document.getElementById("user_notes_list").appendChild(newUserNote); 
		// apply alternating color
			colorUserNotes();
		// scroll to new note
			$('html, body').animate({
				scrollTop: $("#userNote_"+new_note_id).offset().top
			}, 400);
	};
}

function padDateTimeString(numberToPad) {
	result=numberToPad;
	if (numberToPad<10)
	{
		result='0'+numberToPad;
	}
	return result;
}

function colorUserNotes(){
	var note_list_item_elements=document.getElementsByClassName("userNoteListItem");
	var i;
	for(i=0;i<note_list_item_elements.length;i++)
	{
		if(i%2==0)
		{
			note_list_item_elements[i].style.background='#EBEBE0';
		}
		else
		{
			note_list_item_elements[i].style.background='#FFE0C2';
		};
	};
}

function deleteUserNote(noteIndex) {
	// abort if global note deletion is in progress
		if(typeof(document.getElementById("confirmationDiv")) !== undefined && document.getElementById("confirmationDiv") !== null)
		{
			if(document.getElementById("confirmationDiv").style.display!='none')
			{
				return;
			};
		};	
	
	// create confirmation dialog, if not already created
		if(typeof(document.getElementById("confirmationDiv")) === undefined || document.getElementById("confirmationDiv") === null)
		{
			createConfirmationDialog();
		};
		
	// un-set previous confirmation dialog "yes" button onclick behavior
		$("#delete_notes_yes_confirmation_button").prop('onclick',null).off('click');
		
	// set confirmation dialog "yes" button onclick function
		$("#delete_notes_yes_confirmation_button").on( "click", 
			function() {
				document.getElementById('confirmationDiv').style.display='none'; 
				removeUserNote(noteIndex);
				// if highlights deletion confirmation dialog is also open, shift it to the bottom
					if(document.getElementById("cancelReaderHighlightsConfirmationDiv") && document.getElementById("cancelReaderHighlightsConfirmationDiv").style.display!='none')
					{
						document.getElementById('cancelReaderHighlightsConfirmationDiv').style.bottom='66px';				
					};
			});	
	
	// set confirmation dialog message
		$("#note_deletion_dialog_message").html("Διαγραφή σημείωσης; ");
		
	// in case user highlights deletion confirmation dialog is open, shift new dialog up and change its color
		if(document.getElementById("cancelReaderHighlightsConfirmationDiv") && document.getElementById("cancelReaderHighlightsConfirmationDiv").style.display!='none')
		{
			document.getElementById('confirmationDiv').style.bottom='121px';
			document.getElementById('confirmationDiv').style.background='#E0EBFF';
			document.getElementById('confirmationDiv').style.borderColor='#527ACC';
		}
		else
		{
			document.getElementById('confirmationDiv').style.bottom='66px';
			document.getElementById('confirmationDiv').style.background='#FFB2B2';
			document.getElementById('confirmationDiv').style.borderColor='#E60000';
		};	
	
	// display confirmation dialog
		document.getElementById('confirmationDiv').style.display='inline-block';
		
	// un-hide target note's border 
		$('#userNote_'+noteIndex).css("border-style", "solid"); 
}

function rerenderUserNote(noteIndex) { //typesets math equations formatted in LaTeX style
	MathJax.Hub.Queue(["Typeset",MathJax.Hub,"userNote_"+noteIndex]);
}

function removeUserNote(noteIndex){
	$('#userNote_'+noteIndex).remove();	
	if($('#user_notes_list').html()=='')
	{
		document.getElementById('user_note_message_div').innerHTML="Δεν έχετε προσθέσει σημειώσεις";		
		document.getElementById('user_note_message_div').style.display="inline-block";
		document.getElementById('delete_user_notes_button').style.display="none";
		document.getElementById('save_user_notes_button').style.display="none";	
	};
	colorUserNotes();
}

function deleteAllUserNotes(){	
	// abort if individual note deletion is in progress
		if(typeof(document.getElementById("confirmationDiv")) !== undefined && document.getElementById("confirmationDiv") !== null)
		{
			if(document.getElementById("confirmationDiv").style.display!='none')
			{
				return;
			};
		};	
	// create confirmation dialog, if not already created
		if(typeof(document.getElementById("confirmationDiv")) === undefined || document.getElementById("confirmationDiv") === null)
		{
			createConfirmationDialog();
		};
		
	// un-set previous confirmation dialog "yes" button onclick behavior
		$("#delete_notes_yes_confirmation_button").prop('onclick',null).off('click');		

	// set confirmation dialog "yes" button onclick function		
		$("#delete_notes_yes_confirmation_button").on( "click", 
			function() {
				document.getElementById('confirmationDiv').style.display='none'; 
				deleteAllUserNotesConfirmed();
				// if highlights deletion confirmation dialog is also open, shift it to the bottom
					if(document.getElementById("cancelReaderHighlightsConfirmationDiv") && document.getElementById("cancelReaderHighlightsConfirmationDiv").style.display!='none')
					{
						document.getElementById('cancelReaderHighlightsConfirmationDiv').style.bottom='66px';				
					};
			});		
	
	// set confirmation dialog message
		$("#note_deletion_dialog_message").html("Διαγραφή όλων των σημειώσεων; ");

	// in case user highlights deletion confirmation dialog is open, shift new dialog up and change its color
		if(document.getElementById("cancelReaderHighlightsConfirmationDiv") && document.getElementById("cancelReaderHighlightsConfirmationDiv").style.display!='none')
		{
			document.getElementById('confirmationDiv').style.bottom='121px';
			document.getElementById('confirmationDiv').style.background='#E0EBFF';
			document.getElementById('confirmationDiv').style.borderColor='#527ACC';
		}
		else
		{
			document.getElementById('confirmationDiv').style.bottom='66px';
			document.getElementById('confirmationDiv').style.background='#FFB2B2';
			document.getElementById('confirmationDiv').style.borderColor='#E60000';
		};

	// mark all notes
		$("li.userNoteListItem").css("border-style", "solid");		
	
	// display confirmation dialog
		document.getElementById('confirmationDiv').style.display='inline-block';	
}

function deleteAllUserNotesConfirmed(){
	var chapterNum=parseInt($('span.chapter_number').first().html(),10);
	localStorage.removeItem('intro_to_electronics_user_notes_chapter_0'+chapterNum);
	$('#user_notes_list').empty();
	document.getElementById('user_note_message_div').innerHTML="Δεν έχετε προσθέσει σημειώσεις";		
	document.getElementById('user_note_message_div').style.display="inline-block";
	document.getElementById('delete_user_notes_button').style.display="none";
	document.getElementById('save_user_notes_button').style.display="none";
}

function createConfirmationDialog(){
	// question mark image
		var questionMarkImageElement = document.createElement("img");
		questionMarkImageElement.src=question_mark_Image.src; 
		questionMarkImageElement.alt="";
		questionMarkImageElement.width=40;
		questionMarkImageElement.style.width="40px";
		questionMarkImageElement.style.height="40px";
		questionMarkImageElement.style.verticalAlign="middle";
	// confirmation message
		var textnode = document.createElement("span");	
		textnode.innerHTML="Διαγραφή σημείωσης; "; 
		textnode.id="note_deletion_dialog_message";
	// buttons
		var yesbuttonelement = document.createElement("button");
		yesbuttonelement.type="button";
		yesbuttonelement.id="delete_notes_yes_confirmation_button";
		var nobuttonelement = document.createElement("button");
		nobuttonelement.type="button";
		var yestextnode = document.createTextNode("Ναι"); 
		var notextnode = document.createTextNode("Όχι"); 
		nobuttonelement.onclick=function(){
			// hide confirmation dialog
				document.getElementById('confirmationDiv').style.display='none';
			// hide selected note's borders
				$("li.userNoteListItem").css("border-style", "none");
			// if highlights deletion confirmation dialog is also open, shift it to the bottom
				if(document.getElementById("cancelReaderHighlightsConfirmationDiv") && document.getElementById("cancelReaderHighlightsConfirmationDiv").style.display!='none')
				{
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.bottom='66px';				
				};
			};
		yesbuttonelement.appendChild(yestextnode); 
		nobuttonelement.appendChild(notextnode); 
	// container
		var divelement = document.createElement("div");
		divelement.id="confirmationDiv";
		divelement.className="userConfirmation";
		divelement.style.display="none"; // keep hidden initially
	// build structure
		divelement.appendChild(questionMarkImageElement);	
		divelement.appendChild(textnode); 
		divelement.appendChild(yesbuttonelement);
		divelement.appendChild(nobuttonelement);
	// append to document
		document.body.appendChild(divelement);		
}

function cleanupMathJax(source_string){
	// strips out MathJax-rendered nodes
		source_string=removeMathjaxSVG(source_string);
		phantom_list=$("<ol></ol>");
		$(phantom_list).html(source_string);	
		$(phantom_list).find('span.MathJax_SVG_Processed').remove().end() ;            
		$(phantom_list).find('span.MathJax_Preview').remove().end();
		$(phantom_list).find('span.MathJax_SVG_Display').remove().end();
		$(phantom_list).find('span.MathJax_SVG').remove().end();
		$(phantom_list).find('script[type="math/tex"]').each(function(){
			var thisVar=this;
			$(thisVar).replaceWith("$"+$(thisVar).html()+"$");
		});
		$(phantom_list).find('script[type="math/tex; mode=display"]').each(function(){
			var thisVar=this;
			$(thisVar).replaceWith("$$"+$(thisVar).html()+"$$");
		});	
		return $(phantom_list).html();
}


//////////////////////
// save user notes ///
//////////////////////

function saveUserNotes(){
	var thisChapterNumber=document.getElementsByClassName("chapter_number")[0].innerHTML;
	setTimeout(window.location.replace("save_user_comments.xhtml#"+thisChapterNumber),3500); //allow all notes to be stored
}

function initializeUserNotesReport(){
	if(checkIfSettingEnabled(8)) //user notes saved in Google Drive
	{
		initializeUserNotesReportGoogleDrive()
	}
	else //user notes saved in Local Storage
	{
		initializeUserNotesReportLocalStorage();
	};
}

function initializeUserNotesReportLocalStorage(){
	$('input.chapter_selector').prop('disabled',true);
	$('input.details_selector').prop('disabled',true);
	for(var i=1;i<9;i++)
	{
		var localStorageContent=localStorageGetDeCompress("intro_to_electronics_user_notes_chapter_0"+i);
		if(localStorageContent!='' && localStorageContent!==null && localStorageContent!='null')
		{
			$('#selected-'+i).prop('disabled',false);
			$('input.details_selector').prop('disabled',false);
			$('input.details_selector').prop('checked',true);
		};
	};
	if(location.hash.substr(1))
	{
		var redirected_from_chapter=location.hash.substr(1);
		var localStorageContent=localStorageGetDeCompress("intro_to_electronics_user_notes_chapter_0"+redirected_from_chapter);
		if(localStorageContent!='' && localStorageContent!==null && localStorageContent!='null')
		{
			$('#selected-'+redirected_from_chapter).prop('checked',false);
			$('#selected-'+redirected_from_chapter).trigger("click");
		};			
	};
}

function initializeUserNotesReportGoogleDrive(){
	$('input.chapter_selector').prop('disabled',true);
	$('input.details_selector').prop('disabled',true);
	var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
	if(google_script_URL==''){return};
	
	function fetchData(callback) {
		var requests = [];
		for (var i=1; i<9; i++) 
		{
			requests.push($.post(google_script_URL, {mode: "getValue", cellID: String.fromCharCode(65 + i)+"1"}));
		}
		$.when.apply($, requests).then(function () {
			var array = $.map(arguments, function (arg) {
				return arg[0];
			});
			callback(array);
		})
	};

	fetchData(function (array) {
		var redirected_from_chapter=0;
		if(location.hash.substr(1))
		{
			redirected_from_chapter=location.hash.substr(1);		
		};		
		for (var i=1; i<9; i++) 
		{
			var stored_notes=LZString.decompressFromUTF16(array[i-1]);
			if(stored_notes!='' && stored_notes!==null && stored_notes!='null')
			{
				if(i==redirected_from_chapter)
				{
					$('#selected-'+i).prop('disabled',false);
					$('#selected-'+i).prop('checked',false);	
					$('#selected-'+i).trigger("click");
				}
				else
				{
					$('#selected-'+i).prop('disabled',false);					
				};
			};
		};
		$('input.details_selector').prop('disabled',false);
		$('input.details_selector').prop('checked',true);		
		updateHTMLReport();
	});	
}

function saveHTMLReport(){
	// create XHTML file content 
		// create dummy section
			var dummy_section=$('<section></section>').html($('#HTML_notes_container').html());
			// remove ids and classes and styles
				$(dummy_section).find("li").removeAttr("id");
				$(dummy_section).find("li").removeAttr("class");
				$(dummy_section).find("li").removeAttr("style");
				$(dummy_section).find("li").find("p").removeAttr("id").end().end();
				$(dummy_section).find("li").find("p").removeAttr("class").end().end();
				$(dummy_section).find("li").find("p").removeAttr("style").end().end();
		// get xhtml content
			var xhtml_content=$(dummy_section).html();
		// clean-up MathJax
			xhtml_content=cleanupMathJax(xhtml_content);
		// compose MathJax script		
			var mathjax_script='';
			mathjax_script+='<script type="text/x-mathjax-config">';
			mathjax_script+='MathJax.Hub.Config({';
			mathjax_script+='jax: ["input/TeX","input/MathML","output/SVG"],';
			mathjax_script+="tex2jax: { inlineMath: [['$','$'],['\\\\(','\\\\)']] },";
			mathjax_script+='extensions: ["tex2jax.js","mml2jax.js","MathEvents.js"],';
			mathjax_script+='TeX: {';
			mathjax_script+='extensions: ["noErrors.js","noUndefined.js","autoload-all.js"]';
			mathjax_script+='},';
			mathjax_script+='showMathMenu: false,';
			mathjax_script+='menuSettings: {';
			mathjax_script+='zoom: "None"';
			mathjax_script+='},';
			mathjax_script+='messageStyle: "none"';
			mathjax_script+='});';
			mathjax_script+='</script>';
			mathjax_script+='<script type="text/javascript"  src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"> </script>';	
		// add <html>, <body>, etc.
			var header_str='<?xml version="1.0" encoding="UTF-8"?>';
			header_str+='<!DOCTYPE html>';
			header_str+='<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="el">';
			header_str+='<head>';
			header_str+='<meta charset="utf-8" />';
			header_str+='<title>Σημειώσεις - Εισαγωγή στην Ηλεκτρονική</title>';
			header_str+='</head>';
			header_str+='<body>';
		// add main section tag
			var section_tag='<section style="font-family:serif;">';
			var footer_str='</section>';
			footer_str+='</body>';
			footer_str+='</html>'
		// assemble content
			xhtml_content=header_str+mathjax_script+section_tag+xhtml_content+footer_str;
	// create filename
		var xhtml_filename='Introduction_to_Electronics_Notes.xhtml';
	// save XHTML file			
		saveAs(
			new Blob(
				[xhtml_content], {type: "application/xhtml+xml;charset=UTF-8"}
			)
			, xhtml_filename
		);			
}

function updateDatetimeTitle(){
	// book title
		if($('#details_selected-1').prop("checked"))
		{
			$("#HTML_notes_bookname").css("display","block");
		}
		else
		{
			$("#HTML_notes_bookname").css("display","none");
		};
	// date-time
		if($('#details_selected-2').prop("checked"))
		{
			$("#HTML_notes_datetime").html(getWeekDay()+', '+getDateTime());
		}
		else
		{
			$("#HTML_notes_datetime").html("");
		};
	// user-defined report title
		$('#HTML_notes_title').html($('#commentsReportTitle').val());
}

function updateHTMLReport(){
	if(checkIfSettingEnabled(8)) //user notes saved in Google Drive
	{
		updateHTMLReportGoogleDrive()
	}
	else //user notes saved in Local Storage
	{
		updateHTMLReportLocalStorage();
	};	
}

function updateHTMLReportLocalStorage(){
	var HTMLChapterTitlesArray=['Εισαγωγικές Γνώσεις', 'Επαφή p-n, Δίοδοι', 'Διπολικά τρανζίστορ', 'Τρανζίστορ επίδρασης πεδίου – MOSFET', 'Ψηφιακά λογικά κυκλώματα ', 'Ενισχυτές', 'Φίλτρα', 'Ταλαντωτές'];
	//reset
		$("#HTML_notes_bookname").css("display","none");
		$("#HTML_notes_datetime").html("");	
	// user-defined report title
		$('#HTML_notes_title').html($('#commentsReportTitle').val());	
	// book title
		if($('#details_selected-1').prop("checked"))
		{
			$("#HTML_notes_bookname").css("display","block");
		};
	// date-time
		if($('#details_selected-2').prop("checked"))
		{
			$("#HTML_notes_datetime").html(getWeekDay()+', '+getDateTime());
		};
	//chapter notes
		var HTML_report_content="";
		for(var i=1;i<9;i++)
		{
			if($('#selected-'+i).prop("checked"))
			{
				var localStorageContent=localStorageGetDeCompress("intro_to_electronics_user_notes_chapter_0"+i);
				if(localStorageContent!='' && localStorageContent!==null && localStorageContent!='null')
				{
					HTML_report_content+='<h4>Kεφάλαιο '+i;
					if($('#details_selected-3').prop("checked"))
					{
						HTML_report_content+=': '+HTMLChapterTitlesArray[i-1];
					};
					HTML_report_content+='</h4>';
					HTML_report_content+='<ol>';
					HTML_report_content+=localStorageContent;
					HTML_report_content+='</ol>';
				};
				HTML_report_content+='<hr/>';
			};
		};
		
		// add to a temporary node
			HTML_notes_body_TMP=$('<section></section>').html(HTML_report_content);
		// remove action links ('delete' and 'typeset math')
			$(HTML_notes_body_TMP).find("li").find("span").remove('.delete_user_note').end().end();
			$(HTML_notes_body_TMP).find("li").find("span").remove('.rerender_user_note').end().end();
		// make comment content not editable
			$(HTML_notes_body_TMP).find("li").find("p").removeAttr("contenteditable").end().end();
		// remove ids, classes and styles
			$(HTML_notes_body_TMP).find("li").removeAttr("id");
			$(HTML_notes_body_TMP).find("li").removeAttr("class");
			$(HTML_notes_body_TMP).find("li").removeAttr("style");
			$(HTML_notes_body_TMP).find("li").find("p").removeAttr("id").end().end();
			$(HTML_notes_body_TMP).find("li").find("p").removeAttr("class").end().end();
			$(HTML_notes_body_TMP).find("li").find("p").removeAttr("style").end().end();
		// append to report
			$('#HTML_notes_body').html($(HTML_notes_body_TMP).html());
		// typeset math
			MathJax.Hub.Queue(["Typeset",MathJax.Hub,"HTML_notes_body"]);
}

function updateHTMLReportGoogleDrive(){
	var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
	if(google_script_URL==''){return};	
	
	var HTMLChapterTitlesArray=['Εισαγωγικές Γνώσεις', 'Επαφή p-n, Δίοδοι', 'Διπολικά τρανζίστορ', 'Τρανζίστορ επίδρασης πεδίου – MOSFET', 'Ψηφιακά λογικά κυκλώματα ', 'Ενισχυτές', 'Φίλτρα', 'Ταλαντωτές'];
	//reset
		$("#HTML_notes_bookname").css("display","none");
		$("#HTML_notes_datetime").html("");	
	// user-defined report title
		$('#HTML_notes_title').html($('#commentsReportTitle').val());	
	// book title
		if($('#details_selected-1').prop("checked"))
		{
			$("#HTML_notes_bookname").css("display","block");
		};
	// date-time
		if($('#details_selected-2').prop("checked"))
		{
			$("#HTML_notes_datetime").html(getWeekDay()+', '+getDateTime());
		};
	//chapter notes
		var HTML_report_content="";

		function fetchData(callback) {
			var requests = [];
			for (var i=1; i<9; i++) 
			{
				requests.push($.post(google_script_URL, {mode: "getValue", cellID: String.fromCharCode(65 + i)+"1"}));
			}
			$.when.apply($, requests).then(function () {
				var array = $.map(arguments, function (arg) {
					return arg[0];
				});
				callback(array);
			})
		};

		fetchData(function (array) {
			for (var i=1; i<9; i++) 
			{
				if($('#selected-'+i).prop("checked"))
				{
					var stored_notes=LZString.decompressFromUTF16(array[i-1]);
					if(stored_notes!='' && stored_notes!==null && stored_notes!='null')
					{
						HTML_report_content+='<h4>Kεφάλαιο '+i;
						if($('#details_selected-3').prop("checked"))
						{
							HTML_report_content+=': '+HTMLChapterTitlesArray[i-1];
						};
						HTML_report_content+='</h4>';
						HTML_report_content+='<ol>';
						HTML_report_content+=stored_notes;
						HTML_report_content+='</ol>';
					};
					HTML_report_content+='<hr/>';
				};
			};
			// add to a temporary node
				HTML_notes_body_TMP=$('<section></section>').html(HTML_report_content);
			// remove action links ('delete' and 'typeset math')
				$(HTML_notes_body_TMP).find("li").find("span").remove('.delete_user_note').end().end();
				$(HTML_notes_body_TMP).find("li").find("span").remove('.rerender_user_note').end().end();
			// make comment content not editable
				$(HTML_notes_body_TMP).find("li").find("p").removeAttr("contenteditable").end().end();
			// remove ids, classes and styles
				$(HTML_notes_body_TMP).find("li").removeAttr("id");
				$(HTML_notes_body_TMP).find("li").removeAttr("class");
				$(HTML_notes_body_TMP).find("li").removeAttr("style");
				$(HTML_notes_body_TMP).find("li").find("p").removeAttr("id").end().end();
				$(HTML_notes_body_TMP).find("li").find("p").removeAttr("class").end().end();
				$(HTML_notes_body_TMP).find("li").find("p").removeAttr("style").end().end();
			// append to report
				$('#HTML_notes_body').html($(HTML_notes_body_TMP).html());
			// typeset math
				MathJax.Hub.Queue(["Typeset",MathJax.Hub,"HTML_notes_body"]);			
		});			
}

function getWeekDay(){
	var d = new Date();
	var days = ["Κυριακή","Δευτέρα","Τρίτη","Τετάρτη","Πέμπτη","Παρασκευή","Σάββατο"];
	return days[d.getDay()];
}

function getDateTime(){
	var d = new Date();
	return d.toLocaleString();
}



/////////////////////////////
// user text highlighting: //
/////////////////////////////

function dumpHighlightsToLocalStorage(){
	document.body.style.cursor="wait";
	// clone the part of the document ('#main_document') where it is allowed to add highlights
		var cloned_main_document = $('#main_document').clone(true);
	// MathJax processed math needs not be stored, since it is re-typeset automatically
		cloned_main_document=revertToMathJaxLaTeX(cloned_main_document);
	// remove bookmark images from section titles (these are re-entered at page reload)
		$(cloned_main_document).find('img.inChapterBookmarkIMG').remove().end();
	// also remove "title" and "style" attributes from section headers (related to bookmarks)
		$(cloned_main_document).find("h2.section").removeAttr("title").end();
		$(cloned_main_document).find("h2.section").removeAttr("style").end();
		$(cloned_main_document).find("h2.subsection").removeAttr("title").end();
		$(cloned_main_document).find("h2.subsection").removeAttr("style").end();
		$(cloned_main_document).find("h2.subsubsection").removeAttr("title").end();
		$(cloned_main_document).find("h2.subsubsection").removeAttr("style").end();
	// comments need not be stored
		cloned_main_document=stripComments($(cloned_main_document).get(0));
	// get current chapter number
		var current_chapter_number=document.getElementsByClassName("chapter_number")[0].innerHTML;
	if(!checkIfSettingEnabled(8)) //highlights saved in Local Storage
	{
		// store locally
			localStorage.removeItem('intro_to_electronics_stored_chapter_content_'+current_chapter_number);
			localStorageSetCompress('intro_to_electronics_stored_chapter_content_'+current_chapter_number, $(cloned_main_document).html());
		document.body.style.cursor="auto";
	}
	else //highlights saved in Google Drive
	{
		var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
		if(google_script_URL==''){document.body.style.cursor="auto"; return;};
		$.post(google_script_URL, {cellID: String.fromCharCode(73 + parseInt(current_chapter_number,10))+"1", cellContent: LZString.compressToUTF16($(cloned_main_document).html()), mode:"setValue"},
			function(){
				document.body.style.cursor="auto";
			}
		);		
	};
}

function putHighlightsInDocument(stored_content){
		stored_content=removeMathjaxSVG(stored_content); // remove MathJax SVG's
		$('#main_document').html(stored_content);
		
	// enable delete onclick for user highlights	
		$("span.reader_highlights").one("click", function(){
			// dump to Local (or remote) Storage
				$(this).contents().unwrap();
				dumpHighlightsToLocalStorage();
		});			
				
	// re-typeset math
		mathJaxStarted();
		// prepare math re-typesetting by restoring the whole document's math to pure LaTeX 
			$('body').find('span.MathJax_Preview').remove().end();
			$('body').find('span.MathJax_SVG_Display').remove().end();
			$('body').find('span.MathJax_SVG').remove().end();
			$('body').find('script[type="math/tex"]').each(function(){
				var thisVar=this;
				$(thisVar).replaceWith("$"+$(thisVar).html()+"$");
			});
			$('body').find('script[type="math/tex; mode=display"]').each(function(){
				var thisVar=this;
				$(thisVar).replaceWith("$$"+$(thisVar).html()+"$$");
			});
		// re-typeset math over the whole document
			MathJax.Hub.Queue(["Typeset",MathJax.Hub],function(){mathJaxFinished();});
		// re-scale scaleable SVG and PNG images
			autoScaleSVGs();
			scalePNGimages();
		// flag completion
			textHighlightInitializationPending=false;
}

var textHighlightInitializationPending=true;
function initializeTextHighlight(){
	if(checkIfSettingEnabled(0)) //text highlighting is enabled, or default settings apply
	{	
		if(typeof(Storage) == "undefined" && !checkIfSettingEnabled(8)) {return};
		$("#main_document").mouseup(function(){
			var sel = handleSelectedText();
		});		
		
		// restore stored page content if exists
			var current_chapter_number=document.getElementsByClassName("chapter_number")[0].innerHTML;

			if(!checkIfSettingEnabled(8)) //highlights saved in Local Storage
			{
				var localstorageContents=localStorageGetDeCompress('intro_to_electronics_stored_chapter_content_'+current_chapter_number);
				if ( localstorageContents === null || localstorageContents =='null' || localstorageContents=='') 
					{
						return;
					};				
				putHighlightsInDocument(localstorageContents);
			}
			else //highlights saved in Google Drive
			{
				textHighlightInitializationPending=true;
				var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
				if(google_script_URL==''){textHighlightInitializationPending=false; return;};
				$.post(google_script_URL, {mode: "getValue", cellID: String.fromCharCode(73 + parseInt(current_chapter_number,10))+"1"}, 
					function(data, status){
						if(status!="success") {textHighlightInitializationPending=false; return;};
						var stored_content=LZString.decompressFromUTF16(data);
						if (stored_content !== null && stored_content !='null' && stored_content!='')
						{
							putHighlightsInDocument(stored_content);
						}
						else
						{
							textHighlightInitializationPending=false;
						};						
					}						
				);				
			};
	}
	else
	{
		// 'remove highlights' button is disabled
			$('#cancelReaderHighlightsButton').attr('src',remove_highlight_inactive_Image.src); 
		// flag completion
			textHighlightInitializationPending=false;
	};
}
	
function clearAllReaderHighlights(){
	if(checkIfSettingEnabled(0)) //text highlighting is enabled, or default settings apply
	{		
		document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_active_Image.src;

		//show confirmation dialog	
			if (document.getElementById("cancelReaderHighlightsConfirmationDiv") === undefined || document.getElementById("cancelReaderHighlightsConfirmationDiv") === null)
			{
				var questionMarkImageElement = document.createElement("img");
				questionMarkImageElement.src=question_mark_Image.src; 
				questionMarkImageElement.alt="";
				questionMarkImageElement.width=40;
				questionMarkImageElement.style.width="40px";
				questionMarkImageElement.style.height="40px";
				questionMarkImageElement.style.verticalAlign="middle";
				var textnode = document.createTextNode("Διαγραφή όλων των επισημάνσεων του κεφαλαίου; "); 
				var divelement = document.createElement("div");
				var yesbuttonelement = document.createElement("button");
				yesbuttonelement.type="button";
				var nobuttonelement = document.createElement("button");
				nobuttonelement.type="button";
				var yestextnode = document.createTextNode("Ναι"); 
				var notextnode = document.createTextNode("Όχι"); 
				divelement.id="cancelReaderHighlightsConfirmationDiv";
				divelement.className="userConfirmation";
				nobuttonelement.onclick=function(){
					// if user notes deletion confirmation dialog is also open, shift it to the bottom
						if(document.getElementById("confirmationDiv") && document.getElementById("confirmationDiv").style.display!='none')
						{
							document.getElementById('confirmationDiv').style.bottom='66px';				
						};				
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.display='none';
					document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_Image.src
					};
				yesbuttonelement.onclick=function(){
					// if user notes deletion confirmation dialog is also open, shift it to the bottom
						if(document.getElementById("confirmationDiv") && document.getElementById("confirmationDiv").style.display!='none')
						{
							document.getElementById('confirmationDiv').style.bottom='66px';				
						};								
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.display='none'; 
					clearAllReaderHighlightsConfirmed();
					};
				yesbuttonelement.appendChild(yestextnode); 
				nobuttonelement.appendChild(notextnode); 
				divelement.appendChild(questionMarkImageElement);	
				divelement.appendChild(textnode); 
				divelement.appendChild(yesbuttonelement);
				divelement.appendChild(nobuttonelement);
				document.body.appendChild(divelement);
			};
			// in case user notes deletion confirmation dialog is open, shift new dialog up and change its color
				if(document.getElementById("confirmationDiv") && document.getElementById("confirmationDiv").style.display!='none')
				{
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.bottom='121px';
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.background='#E0EBFF';
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.borderColor='#527ACC';
				}
				else
				{
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.bottom='66px';
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.background='#FFB2B2';
					document.getElementById('cancelReaderHighlightsConfirmationDiv').style.borderColor='#E60000';
				};
			// show confirmation dialog
				document.getElementById('cancelReaderHighlightsConfirmationDiv').style.display='inline-block';
	};
}

function clearAllReaderHighlightsConfirmed(){
	document.body.style.cursor="wait";	
	//avoid marking search terms multiple times
		$("span.searchTermHighlight").contents().unwrap(); 
		$("span.searchTermHighlight").remove().end();
	// clear user highlights
		$("span.reader_highlights").contents().unwrap();
		$("span.reader_highlights").remove().end();
	var current_chapter_number=document.getElementsByClassName("chapter_number")[0].innerHTML;
	if(!checkIfSettingEnabled(8)) //highlights saved in Local Storage
	{
		if(typeof(Storage) == "undefined") 
		{
			document.body.style.cursor="auto";  
			document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_Image.src;
			return;
		};
		localStorage.removeItem('intro_to_electronics_stored_chapter_content_'+current_chapter_number);
		document.body.style.cursor="auto";
		setTimeout(function(){document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_Image.src},1500);
		
	}
	else //highlights saved in Google Drive
	{
		var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
		if(google_script_URL==''){document.body.style.cursor="auto"; return;};
		$.post(google_script_URL, {cellID: String.fromCharCode(73 + parseInt(current_chapter_number,10))+"1", cellContent: "", mode:"setValue"},
			function(){
				document.body.style.cursor="auto";
				document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_Image.src;
			}
		);			
	};		
}

function handleSelectedText() {	
	if(mathJaxWorking==true){return};
	if(typeof(Storage) == "undefined" && !checkIfSettingEnabled(8)) {return};
	document.body.style.cursor="wait";
	//avoid marking search terms multiple times
		$("span.searchTermHighlight").contents().unwrap(); 
		$("span.searchTermHighlight").remove();	
		
	try{
		var selection_object;
		if (window.getSelection) {
			selection_object = window.getSelection();
		} else if (document.getSelection) {
			selection_object = document.getSelection();
		} else if (document.selection) {
			selection_object = document.selection.createRange().text;
		}
		var textRange = selection_object.getRangeAt(0);
		if(textRange.toString()=='')
		{
			document.getSelection().removeAllRanges();
			document.body.style.cursor="auto";
			return;
		};
		
		// expand selection to complete words
			if (window.getSelection && (selection_object = window.getSelection()).modify)
			{
				var endNode = selection_object.focusNode;
				var endOffset = selection_object.focusOffset;
                selection_object.collapse(selection_object.anchorNode, selection_object.anchorOffset);
                selection_object.modify("move", "forward", "character");
                selection_object.modify("move", "backward", "word");
                selection_object.extend(endNode, endOffset);
                selection_object.modify("extend", "backward", "character");
                selection_object.modify("extend", "forward", "word");
				textRange = selection_object.getRangeAt(0);				
			}
			else if ( (selection_object = document.selection) && selection_object.type != "Control")
			{
				textRange.expand("word");
				// Move the end back to not include the word's trailing space(s), if necessary
					while (/\s$/.test(textRange.text)) {
						textRange.moveEnd("character", -1);
					}; 				
			};	          
       
		// wrap selection in container "span"		
			var  span_wrapper = document.createElement("span"); 
			span_wrapper.style.cursor="url(../images/misc/remove_highlights_cursor.cur), url(../images/misc/remove_highlights_cursor.png), pointer";
			span_wrapper.title="κατάργηση επισήμανσης";			
			span_wrapper.className="reader_highlights";				
	
			textRange.surroundContents(span_wrapper);
			span_wrapper=revertToMathJaxLaTeX(span_wrapper); // revert to pure LaTeX
			
			MathJax.Hub.Queue(["Typeset",MathJax.Hub,span_wrapper]); // if highlight contains math, refresh
			
			document.getSelection().removeAllRanges();			
	
		// enable delete onclick for new (and old ...) user highlights	
			$("span.reader_highlights").one("click", function(){
				// dump to Local Storage
					$(this).contents().unwrap();
					dumpHighlightsToLocalStorage();
			});	

		// dump to Local Storage
			dumpHighlightsToLocalStorage();
	}
	catch(err)
	{
		try{document.getSelection().removeAllRanges();}catch(err){};
		document.getElementById('cancelReaderHighlightsButton').src=remove_highlight_Image.src;
		document.body.style.cursor="auto";
		return
	};
	document.body.style.cursor="auto";
}

function revertToMathJaxLaTeX(source_element){
	// revert MathJax math to its original LaTeX form            
		$(source_element).find('span.MathJax_Preview').remove().end();
		$(source_element).find('span.MathJax_SVG_Display').remove().end();
		$(source_element).find('span.MathJax_SVG').remove().end();
		$(source_element).find('script[type="math/tex"]').each(function(){
			var thisVar=this;
			$(thisVar).replaceWith("$"+$(thisVar).html()+"$");
		});
		$(source_element).find('script[type="math/tex; mode=display"]').each(function(){
			var thisVar=this;
			$(thisVar).replaceWith("$$"+$(thisVar).html()+"$$");
		});	
		return source_element;
}

// blinking indicator while math is loading:
var mathJaxWorking=false;
function mathJaxStarted(){
	mathJaxWorking=true;
	document.body.style.cursor="wait";
	document.getElementById('blinking_indicator').src=red_indicator_Image.src;
	var floatdiv_element=document.getElementById('floatdiv');
	if(floatdiv_element.className=='floatdiv_vertical')
	{
		floatdiv_element.style.background="#FF8080";
	};	
}

function mathJaxFinished(){
	setTimeout(function(){
		document.getElementById('blinking_indicator').src=green_indicator_Image.src;
		mathJaxWorking=false;
		document.body.style.cursor="auto";
		var floatdiv_element=document.getElementById('floatdiv');		
		if(floatdiv_element.className=='floatdiv_vertical')
		{
			floatdiv_element.style.background="#E0E0EB";
		}
		else
		{
			floatdiv_element.style.background="#B6B6BF";
		};
	},2000)
}

function removeMathjaxSVG(input_string){
	var left_index=0;
	var right_index=0;
	var output_string='';
	while(left_index!=-1)
	{
		left_index=input_string.indexOf('<svg');
		if(left_index==-1){break}
		output_string=output_string+input_string.substring(0,left_index);
		right_index=input_string.indexOf('</svg>')+6;
		input_string=input_string.substr(right_index);
	}
	return output_string+input_string;
}

function stripComments(node_element){
	if(node_element.childNodes.length==0)
	{
		if(node_element.nodeType==8)
		{
			node_element.parentNode.removeChild(node_element);
		};
	}
	else
	{
		for(var i=0;i<node_element.childNodes.length;i++)
		{
			stripComments(node_element.childNodes[i]);
		};		
	};
	return node_element;
}





